﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Data.SqlClient;
using System.Data;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Web;
using System.Collections;
using xamGridIsolatedSampleProject.Web;

namespace xamGridIsolatedSampleProject.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class ServiceApp
    {
        [OperationContract]
        public void DoWork()
        {
            // Add your operation implementation here
            return;
        }

        // Add more operations here and mark them with [OperationContract]




        [OperationContract]
        public List<Aktivnosti> GetAktivnosti(string strZILIF, int id_zadavaca)
        {
            List<Aktivnosti> list = new List<Aktivnosti>();
            string nwConn = System.Configuration.ConfigurationManager.ConnectionStrings["myConnectionString"].ConnectionString;
            using (SqlConnection conn = new SqlConnection(nwConn))
            {
                conn.Open();

                string sqlquery = "";
                if (strZILIF == "zaposleni")/* TIP = INTERNI    or   TIP = TEREN */
                {
                    sqlquery = "declare @idzaps int " +
                                "set @idzaps = " + id_zadavaca.ToString() + " " +
                                "select ak.idaktivnosti,ak.idzadavaca, " +
                                "(select ltrim(rtrim(fr.PUNNAZIVFIRME)) from FIRME fr where fr.IDFIRME = ak.IDZADAVACA) as 'PROJEKTANT', " +
                                "ak.idzaposlenog, " +
                                "(select ltrim(rtrim(kr.PUNNAZIVKORISNIKA)) from KORISNICI kr where kr.IDZAPOSLENOG = ak.IDZAPOSLENOG) as 'ZAPOSLENI', " +
                                "ak.idprojekta, " +
                                "(select ltrim(rtrim(pj.nazivprojekta)) from PROJEKTI pj where pj.IDPROJEKTA = ak.IDPROJEKTA) as 'PROJEKATNAZIV', " +
                                "ltrim(rtrim(ak.OPISZAHTEVA)) as 'OPISZAHTEVA',ltrim(rtrim(ak.OPISAKTIVNOSTI)) as 'OPISAKTIVNOSTI',ltrim(rtrim(ak.TIP)) as 'TIP',ltrim(rtrim(ak.ZILIA)) as 'ZILIA',ak.idstatusa, " +
                                "(select CASE IDSTATUSA WHEN 1 THEN 'REALIZOVAN' ELSE 'NEREALIZOVAN' END 'STATUS') as 'STATUS', " +
                                "ISNULL(ROKIZVRSENJA,'1900-01-01 00:00:00.000' ) as 'ROKIZVRSENJA'," +
                                "ISNULL(VREMEPOCETKA,'1900-01-01 00:00:00.000' ) as 'VREMEPOCETKA'," +
                                "ISNULL(VREMEZAVRSETKA,'1900-01-01 00:00:00.000') as 'VREMEZAVRSETKA' " +
                                "from AKTIVNOSTI ak where (ltrim(rtrim(ak.TIP)) = 'TEREN' or ltrim(rtrim(ak.TIP)) = 'EXTERNI') and ak.IDZAPOSLENOG = @idzaps " +
                                "union " +
                                "select ak.idaktivnosti,ak.idzadavaca, " +
                                "(select ltrim(rtrim(zp.PUNNAZIVZAPOSLENOG)) from ZAPOSLENI zp where zp.IDZAPOSLENOG = ak.IDZADAVACA) as 'PROJEKTANT', " +
                                "ak.idzaposlenog, " +
                                "(select ltrim(rtrim(kr.PUNNAZIVKORISNIKA)) from KORISNICI kr where kr.IDZAPOSLENOG = ak.IDZAPOSLENOG) as 'ZAPOSLENI', " +
                                "ak.idprojekta, " +
                                "(select ltrim(rtrim(pj.nazivprojekta)) from PROJEKTI pj where pj.IDPROJEKTA = ak.IDPROJEKTA) as 'PROJEKATNAZIV', " +
                                "ltrim(rtrim(ak.OPISZAHTEVA)) as 'OPISZAHTEVA',ltrim(rtrim(ak.OPISAKTIVNOSTI)) as 'OPISAKTIVNOSTI',ltrim(rtrim(ak.TIP)) as 'TIP',ltrim(rtrim(ak.ZILIA)) as 'ZILIA',ak.idstatusa, " +
                                "(select CASE IDSTATUSA WHEN 1 THEN 'REALIZOVAN' ELSE 'NEREALIZOVAN' END 'STATUS') as 'STATUS', " +
                                "ISNULL(ROKIZVRSENJA,'1900-01-01 00:00:00.000' ) as 'ROKIZVRSENJA'," +
                                "ISNULL(VREMEPOCETKA,'1900-01-01 00:00:00.000' ) as 'VREMEPOCETKA'," +
                                "ISNULL(VREMEZAVRSETKA,'1900-01-01 00:00:00.000') as 'VREMEZAVRSETKA' " +
                                "from AKTIVNOSTI ak where (ltrim(rtrim(ak.TIP)) = 'INTERNI') and ak.IDZAPOSLENOG = @idzaps " +
                                "union " +
                                "SELECT ak.idaktivnosti,ak.idzadavaca, " +
                                "(select ltrim(rtrim(zp.PUNNAZIVZAPOSLENOG)) from ZAPOSLENI zp where zp.IDZAPOSLENOG = ak.IDZADAVACA) as 'PROJEKTANT', " +
                                "ak.idzaposlenog, " +
                                "(select ltrim(rtrim(kr.PUNNAZIVKORISNIKA)) from KORISNICI kr where kr.IDZAPOSLENOG = ak.IDZAPOSLENOG) as 'ZAPOSLENI', " +
                                "ak.idprojekta, " +
                                "(select ltrim(rtrim(pj.nazivprojekta)) from PROJEKTI pj where pj.IDPROJEKTA = ak.IDPROJEKTA) as 'PROJEKATNAZIV', " +
                                "ltrim(rtrim(ak.OPISZAHTEVA)) as 'OPISZAHTEVA',ltrim(rtrim(ak.OPISAKTIVNOSTI)) as 'OPISAKTIVNOSTI',ltrim(rtrim(ak.TIP)) as 'TIP',ltrim(rtrim(ak.ZILIA)) as 'ZILIA',ak.idstatusa, " +
                                "(select CASE IDSTATUSA WHEN 1 THEN 'REALIZOVAN' ELSE 'NEREALIZOVAN' END 'STATUS') as 'STATUS', " +
                                "ISNULL(ROKIZVRSENJA,'1900-01-01 00:00:00.000' ) as 'ROKIZVRSENJA'," +
                                "ISNULL(VREMEPOCETKA,'1900-01-01 00:00:00.000' ) as 'VREMEPOCETKA'," +
                                "ISNULL(VREMEZAVRSETKA,'1900-01-01 00:00:00.000') as 'VREMEZAVRSETKA' " +
                                "FROM AKTIVNOSTI ak WHERE ltrim(rtrim(ak.TIP)) = 'INTERNI' and ak.idzadavaca = @idzaps";
                }
                else if (strZILIF == "firma")/* TIP = EXTERNI */
                {
                    sqlquery = "declare @idzadv int " +
                    "set @idzadv = " + id_zadavaca.ToString() + " " +
                    "select ak.idaktivnosti,ak.idzadavaca, " +
                    "(select ltrim(rtrim(fr.PUNNAZIVFIRME)) from FIRME fr where fr.IDFIRME = ak.IDZADAVACA) as 'PROJEKTANT', " +
                    "ak.idzaposlenog, " +
                    "(select ltrim(rtrim(kr.PUNNAZIVKORISNIKA)) from KORISNICI kr where kr.IDZAPOSLENOG = ak.IDZAPOSLENOG) as 'ZAPOSLENI', " +
                    "ak.idprojekta, " +
                    "(select ltrim(rtrim(pj.nazivprojekta)) from PROJEKTI pj where pj.IDPROJEKTA = ak.IDPROJEKTA) as 'PROJEKATNAZIV', " +
                    "ltrim(rtrim(ak.OPISZAHTEVA)) as 'OPISZAHTEVA',ltrim(rtrim(ak.OPISAKTIVNOSTI)) as 'OPISAKTIVNOSTI',ltrim(rtrim(ak.TIP)) as 'TIP',ltrim(rtrim(ak.ZILIA)) as 'ZILIA',ak.idstatusa, " +
                    "(select CASE IDSTATUSA WHEN 1 THEN 'REALIZOVAN' ELSE 'NEREALIZOVAN' END 'STATUS') as 'STATUS', " +
                    "ISNULL(ROKIZVRSENJA, '1900-01-01 00:00:00.000' ) as 'ROKIZVRSENJA'," +
                    "ISNULL(VREMEPOCETKA, '1900-01-01 00:00:00.000' ) as 'VREMEPOCETKA'," +
                    "ISNULL(VREMEZAVRSETKA,'1900-01-01 00:00:00.000') as 'VREMEZAVRSETKA' " +
                    "from aktivnosti ak where ak.IDZADAVACA = @idzadv and (ltrim(rtrim(ak.TIP)) = 'EXTERNI' or ltrim(rtrim(ak.TIP)) = 'TEREN')";
                }

                using (SqlCommand dCmd = new SqlCommand(sqlquery, conn))
                {
                    dCmd.CommandType = CommandType.Text;
                    using (SqlDataReader reader = dCmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            list.Add(new Aktivnosti
                            {
                                /* IDAKTIVNOSTI IDZADAVACA IDZAPOSLENOG IDPROJEKTA OPISZAHTEVA OPISAKTIVNOSTI TIP ZILIA STATUS ROKIZVRSENJA VREMEPOCETKA VREMEZAVRSETKA */
                                /*
                                    IDAKTIVNOSTI
                                    IDZADAVACA
                                    PROJEKTANT
                                    IDZAPOSLENOG
                                    ZAPOSLENI
                                    IDPROJEKTA
                                    PROJEKATNAZIV
                                    OPISZAHTEVA 
                                    OPISAKTIVNOSTI
                                    TIP
                                    ZILIA
                                    IDSTATUSA
                                    STATUS
                                    ROKIZVRSENJA 
                                    VREMEPOCETKA 
                                    VREMEZAVRSETKA
                                 */
                                IDAKTIVNOSTI = Convert.ToInt32(reader[0].ToString()),
                                IDZADAVACA = Convert.ToInt32(reader[1].ToString()),
                                PROJEKTANT = reader[2].ToString(),
                                IDZAPOSLENOG = Convert.ToInt32(reader[3].ToString()),
                                ZAPOSLENI = reader[4].ToString(),
                                IDPROJEKTA = Convert.ToInt32(reader[5].ToString()),
                                PROJEKATNAZIV = reader[6].ToString(),
                                OPISZAHTEVA = reader[7].ToString(),
                                OPISAKTIVNOSTI = reader[8].ToString(),
                                TIP = reader[9].ToString(),
                                ZILIA = reader[10].ToString(),
                                IDSTATUSA = Convert.ToInt32(reader[11].ToString()),
                                STATUS = reader[12].ToString(),
                                ROKIZVRSENJA = Convert.ToDateTime(reader[13].ToString()),
                                VREMEPOCETKA = Convert.ToDateTime(reader[14].ToString()),
                                VREMEZAVRSETKA = Convert.ToDateTime(reader[15].ToString())
                            });
                        }
                    }
                } conn.Close();
            } return list;
        }













    }
}
